/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of DBus.xs. Do not edit this file, edit DBus.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "DBus.xs"
/* -*- c -*-
 *
 * Copyright (C) 2004-2011 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under the same terms as Perl itself. Either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "COPYING" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <dbus/dbus.h>

#if NET_DBUS_DEBUG
static int net_dbus_debug = 0;
#define DEBUG_MSG(...) if (net_dbus_debug) fprintf(stderr, __VA_ARGS__)
#else
#define DEBUG_MSG(...)
#endif

#ifdef __GNUC__
# define ignore_value(x) (({ __typeof__ (x) __x = (x); (void) __x; }))
#else
# define ignore_value(x) x
#endif

/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

dbus_int64_t
_dbus_parse_int64(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    //DEBUG_MSG("Parrse %s\n", SvPV_nolen(sv));
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}

dbus_uint64_t
_dbus_parse_uint64(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvUV(sv);
#else
    //DEBUG_MSG("Parrse %s\n", SvPV_nolen(sv));
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif

SV *
_dbus_format_int64(dbus_int64_t val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    //DEBUG_MSG("Format i64 [%" PRId64 "] to [%s]\n", val, buf);
    return newSVpv(buf, len);
#endif
}

#ifndef PRIu64
#define PRIu64 "llu"
#endif

SV *
_dbus_format_uint64(dbus_uint64_t val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    //DEBUG_MSG("Format u64 [%" PRIu64 "] to [%s]\n", val, buf);
    return newSVpv(buf, len);
#endif
}



/* The -1 is required by the contract for
   dbus_{server,connection}_allocate_slot
   initialization */
dbus_int32_t connection_data_slot = -1;
dbus_int32_t server_data_slot = -1;
dbus_int32_t pending_call_data_slot = -1;

void
_object_release(void *obj) {
    DEBUG_MSG("Releasing object count on %p\n", obj);
    SvREFCNT_dec((SV*)obj);
}

dbus_bool_t
_watch_generic(DBusWatch *watch, void *data, char *key, dbus_bool_t server) {
    SV *selfref;
    HV *self;
    SV **call;
    SV *h_sv;
    dSP;

    DEBUG_MSG("Watch generic callback %p %p %s %d\n", watch, data, key, server);

    if (server) {
      selfref = (SV*)dbus_server_get_data((DBusServer*)data, server_data_slot);
    } else {
      selfref = (SV*)dbus_connection_get_data((DBusConnection*)data, connection_data_slot);
    }
    self = (HV*)SvRV(selfref);

    DEBUG_MSG("Got owner %p\n", self);

    call = hv_fetch(self, key, strlen(key), 0);

    if (!call) {
      warn("Could not find watch callback %s for fd %d\n",
	   key, dbus_watch_get_unix_fd(watch));
      return FALSE;
    }

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(selfref);
    h_sv = sv_newmortal();
    sv_setref_pv(h_sv, "Net::DBus::Binding::C::Watch", (void*)watch);
    XPUSHs(h_sv);
    PUTBACK;

    call_sv(*call, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 1;
}

dbus_bool_t
_watch_server_add(DBusWatch *watch, void *data) {
    return _watch_generic(watch, data, "add_watch", 1);
}
void
_watch_server_remove(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "remove_watch", 1);
}
void
_watch_server_toggled(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "toggled_watch", 1);
}

dbus_bool_t
_watch_connection_add(DBusWatch *watch, void *data) {
    return _watch_generic(watch, data, "add_watch", 0);
}
void
_watch_connection_remove(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "remove_watch", 0);
}
void
_watch_connection_toggled(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "toggled_watch", 0);
}


dbus_bool_t
_timeout_generic(DBusTimeout *timeout, void *data, char *key, dbus_bool_t server) {
    SV *selfref;
    HV *self;
    SV **call;
    SV *h_sv;
    dSP;

    if (server) {
      selfref = (SV*)dbus_server_get_data((DBusServer*)data, server_data_slot);
    } else {
      selfref = (SV*)dbus_connection_get_data((DBusConnection*)data, connection_data_slot);
    }
    self = (HV*)SvRV(selfref);

    call = hv_fetch(self, key, strlen(key), 0);

    if (!call) {
      warn("Could not find timeout callback for %s\n", key);
      return FALSE;
    }

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs((SV*)selfref);
    h_sv = sv_newmortal();
    sv_setref_pv(h_sv, "Net::DBus::Binding::C::Timeout", (void*)timeout);
    XPUSHs(h_sv);
    PUTBACK;

    call_sv(*call, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 1;
}

dbus_bool_t
_timeout_server_add(DBusTimeout *timeout, void *data) {
    return _timeout_generic(timeout, data, "add_timeout", 1);
}
void
_timeout_server_remove(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "remove_timeout", 1);
}
void
_timeout_server_toggled(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "toggled_timeout", 1);
}

dbus_bool_t
_timeout_connection_add(DBusTimeout *timeout, void *data) {
    return _timeout_generic(timeout, data, "add_timeout", 0);
}
void
_timeout_connection_remove(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "remove_timeout", 0);
}
void
_timeout_connection_toggled(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "toggled_timeout", 0);
}

void
_connection_callback (DBusServer *server,
		      DBusConnection *new_connection,
		      void *data) {
    SV *selfref = (SV*)dbus_server_get_data((DBusServer*)data, server_data_slot);
    HV *self = (HV*)SvRV(selfref);
    SV **call;
    SV *value;
    dSP;

    call = hv_fetch(self, "_callback", strlen("_callback"), 0);

    if (!call) {
      warn("Could not find new connection callback\n");
      return;
    }

    DEBUG_MSG("Created connection in callback %p\n", new_connection);
    /* The DESTROY method will de-ref it later */
    dbus_connection_ref(new_connection);

    value = sv_newmortal();
    sv_setref_pv(value, "Net::DBus::Binding::C::Connection", (void*)new_connection);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(selfref);
    XPUSHs(value);
    PUTBACK;

    call_sv(*call, G_DISCARD);

    FREETMPS;
    LEAVE;
}


DBusHandlerResult
_message_filter(DBusConnection *con,
		DBusMessage *msg,
		void *data) {
    SV *selfref;
    SV *value;
    int count;
    int handled = 0;
    dSP;

    selfref = (SV*)dbus_connection_get_data(con, connection_data_slot);

    DEBUG_MSG("Create message in filter %p\n", msg);
    DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
    DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
    DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
    DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
    /* Will be de-refed in the DESTROY method */
    dbus_message_ref(msg);
    value = sv_newmortal();
    sv_setref_pv(value, "Net::DBus::Binding::C::Message", (void*)msg);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs((SV*)selfref);
    XPUSHs(value);
    XPUSHs(data);
    PUTBACK;

    count = call_method("_message_filter", G_SCALAR);
    SPAGAIN;
    if (count == 1) {
      handled = POPi;
    } else {
      handled = 0;
    }
    PUTBACK;
    DEBUG_MSG("Handled %d %d\n", count, handled);
    FREETMPS;
    LEAVE;

    return handled ? DBUS_HANDLER_RESULT_HANDLED : DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
}

void
_pending_call_callback(DBusPendingCall *call,
		       void *data) {
    SV *selfref;
    dSP;

    DEBUG_MSG("In pending call callback %p\n", call);
    selfref = (SV*)dbus_pending_call_get_data(call, pending_call_data_slot);

    dbus_pending_call_ref(call);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs((SV*)selfref);
    PUTBACK;

    call_sv(data, G_DISCARD);

    FREETMPS;
    LEAVE;
}

void
_filter_release(void *data) {
    SvREFCNT_dec(data);
}

void
_pending_call_notify_release(void *data) {
    SvREFCNT_dec(data);
}

void
_path_unregister_callback(DBusConnection *con,
			  void *data) {
    SvREFCNT_dec(data);
}

DBusHandlerResult
_path_message_callback(DBusConnection *con,
		       DBusMessage *msg,
		       void *data) {
    SV *self = (SV*)dbus_connection_get_data(con, connection_data_slot);
    SV *value;
    dSP;

    DEBUG_MSG("Got message in callback %p\n", msg);
    DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
    DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
    DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
    DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
    /* Will be de-refed in the DESTROY method */
    dbus_message_ref(msg);
    value = sv_newmortal();
    sv_setref_pv(value, "Net::DBus::Binding::C::Message", (void*)msg);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(self);
    XPUSHs(value);
    PUTBACK;

    call_sv((SV*)data, G_DISCARD);

    FREETMPS;
    LEAVE;

    return DBUS_HANDLER_RESULT_HANDLED;
}

DBusObjectPathVTable _path_callback_vtable = {
	_path_unregister_callback,
	_path_message_callback,
	NULL,
	NULL,
	NULL,
	NULL
};

SV *
_sv_from_error (DBusError *error)
{
    HV *hv;

    if (!error) {
      warn ("error is NULL");
      return &PL_sv_undef;
    }

    if (!dbus_error_is_set (error)) {
      warn ("error is unset");
      return &PL_sv_undef;
    }

    hv = newHV ();

    /* map DBusError attributes to hash keys */
    ignore_value(hv_store (hv, "name", 4, newSVpv (error->name, 0), 0));
    ignore_value(hv_store (hv, "message", 7, newSVpv (error->message, 0), 0));

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Net::DBus::Error", TRUE));
}

void
_croak_error (DBusError *error)
{
    sv_setsv (ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    dbus_error_free (error);

    croak (Nullch);
}

void
_populate_constant(HV *href, char *name, int val)
{
    ignore_value(hv_store(href, name, strlen(name), newSViv(val), 0));
}

#define REGISTER_CONSTANT(name, key) _populate_constant(constants, #key, name)

#line 474 "DBus.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 616 "DBus.c"

XS_EUPXS(XS_Net__DBus__Binding__Connection__open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Connection__open)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "address");
    {
	char *	address = (char *)SvPV_nolen(ST(0))
;
#line 526 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 630 "DBus.c"
	DBusConnection *	RETVAL;
#line 529 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open connection shared %s\n", address);
	con = dbus_connection_open(address, &error);
	if (!con) {
	  _croak_error (&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 641 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Connection__open_private); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Connection__open_private)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "address");
    {
	char *	address = (char *)SvPV_nolen(ST(0))
;
#line 544 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 661 "DBus.c"
	DBusConnection *	RETVAL;
#line 547 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open connection private %s\n", address);
	con = dbus_connection_open_private(address, &error);
	if (!con) {
	  _croak_error (&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 672 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__set_owner); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__set_owner)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, owner");
    {
	DBusConnection *	con;
	SV *	owner = ST(1)
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_set_owner() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 565 "DBus.xs"
	SvREFCNT_inc(owner);
	dbus_connection_set_data(con, connection_data_slot, owner, _object_release);
#line 701 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_disconnect() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 572 "DBus.xs"
	DEBUG_MSG("Closing connection %p\n", con);
	dbus_connection_close(con);
#line 726 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_ref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_ref)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_ref() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_connection_ref(con);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_unref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_unref)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_unref() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_connection_unref(con);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_connected); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_connected)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_get_is_connected() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_connection_get_is_connected(con);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_authenticated); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_authenticated)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_get_is_authenticated() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_connection_get_is_authenticated(con);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_flush() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_connection_flush(con);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__send)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, msg");
    {
	DBusConnection *	con;
	DBusMessage *	msg;
#line 600 "DBus.xs"
	dbus_uint32_t serial;
#line 864 "DBus.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 602 "DBus.xs"
	if (!dbus_connection_send(con, msg, &serial)) {
	  croak("not enough memory to send message");
	}
	RETVAL = serial;
#line 888 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__send_with_reply_and_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__send_with_reply_and_block)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, msg, timeout");
    {
	DBusConnection *	con;
	DBusMessage *	msg;
	int	timeout = (int)SvIV(ST(2))
;
#line 615 "DBus.xs"
	DBusMessage *reply;
	DBusError error;
#line 909 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply_and_block() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply_and_block() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 618 "DBus.xs"
	dbus_error_init(&error);
	if (!(reply = dbus_connection_send_with_reply_and_block(con, msg, timeout, &error))) {
	  _croak_error(&error);
	}
	DEBUG_MSG("Create msg reply %p\n", reply);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(reply));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(reply) ? dbus_message_get_interface(reply) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(reply) ? dbus_message_get_path(reply) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(reply) ? dbus_message_get_member(reply) : "");
	RETVAL = reply;
#line 938 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__send_with_reply); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__send_with_reply)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, msg, timeout");
    {
	DBusConnection *	con;
	DBusMessage *	msg;
	int	timeout = (int)SvIV(ST(2))
;
#line 638 "DBus.xs"
	DBusPendingCall *reply;
#line 959 "DBus.c"
	DBusPendingCall *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 640 "DBus.xs"
	if (!dbus_connection_send_with_reply(con, msg, &reply, timeout)) {
	  croak("not enough memory to send message");
	}
	DEBUG_MSG("Create pending call %p\n", reply);
	RETVAL = reply;
#line 983 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::PendingCall", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_borrow_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_borrow_message)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_borrow_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_connection_borrow_message(con);
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_return_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_return_message)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, msg");
    {
	DBusConnection *	con;
	DBusMessage *	msg;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_return_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_return_message() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_connection_return_message(con, msg);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_steal_borrowed_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_steal_borrowed_message)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, msg");
    {
	DBusConnection *	con;
	DBusMessage *	msg;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_connection_steal_borrowed_message(con, msg);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_pop_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_connection_pop_message)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_pop_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_connection_pop_message(con);
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__dispatch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__dispatch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_dispatch() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 670 "DBus.xs"
	DEBUG_MSG("IN dispatch\n");
	while(dbus_connection_dispatch(con) == DBUS_DISPATCH_DATA_REMAINS);
	DEBUG_MSG("Completed \n");
#line 1127 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__set_watch_callbacks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__set_watch_callbacks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_set_watch_callbacks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 678 "DBus.xs"
	if (!dbus_connection_set_watch_functions(con,
						 _watch_connection_add,
						 _watch_connection_remove,
						 _watch_connection_toggled,
						 con, NULL)) {
	  croak("not enough memory to set watch functions on connection");
	}
#line 1157 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__set_timeout_callbacks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__set_timeout_callbacks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_set_timeout_callbacks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 690 "DBus.xs"
	if (!dbus_connection_set_timeout_functions(con,
						   _timeout_connection_add,
						   _timeout_connection_remove,
						   _timeout_connection_toggled,
						   con, NULL)) {
	  croak("not enough memory to set timeout functions on connection");
	}
#line 1187 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__register_object_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__register_object_path)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, path, code");
    {
	DBusConnection *	con;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	SV *	code = ST(2)
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_register_object_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 704 "DBus.xs"
	SvREFCNT_inc(code);
	if (!(dbus_connection_register_object_path(con, path, &_path_callback_vtable, code))) {
	  croak("failure when registering object path");
	}
#line 1218 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__unregister_object_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__unregister_object_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, path");
    {
	DBusConnection *	con;
	char *	path = (char *)SvPV_nolen(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_unregister_object_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 714 "DBus.xs"
	/* The associated data will be free'd by the previously
	   registered callback */
	if (!(dbus_connection_unregister_object_path(con, path))) {
	  croak("failure when unregistering object path");
	}
#line 1248 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__register_fallback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__register_fallback)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, path, code");
    {
	DBusConnection *	con;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	SV *	code = ST(2)
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_register_fallback() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 726 "DBus.xs"
	SvREFCNT_inc(code);
	if (!(dbus_connection_register_fallback(con, path, &_path_callback_vtable, code))) {
	  croak("failure when registering fallback object path");
	}
#line 1279 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection__add_filter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection__add_filter)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, code");
    {
	DBusConnection *	con;
	SV *	code = ST(1)
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_add_filter() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 737 "DBus.xs"
	SvREFCNT_inc(code);
	DEBUG_MSG("Adding filter %p\n", code);
	dbus_connection_add_filter(con, _message_filter, code, _filter_release);
#line 1307 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_register); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_register)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;
#line 745 "DBus.xs"
	DBusError error;
	int reply;
#line 1324 "DBus.c"
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_register() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 748 "DBus.xs"
	dbus_error_init(&error);
	if (!(reply = dbus_bus_register(con, &error))) {
	  _croak_error(&error);
	}
	RETVAL = reply;
#line 1340 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_add_match); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_add_match)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, rule");
    {
	DBusConnection *	con;
	char *	rule = (char *)SvPV_nolen(ST(1))
;
#line 761 "DBus.xs"
	DBusError error;
#line 1360 "DBus.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_add_match() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 763 "DBus.xs"
	dbus_error_init(&error);
	DEBUG_MSG("Adding match %s\n", rule);
	dbus_bus_add_match(con, rule, &error);
	if (dbus_error_is_set(&error)) {
	  _croak_error(&error);
	}
#line 1376 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_remove_match); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_remove_match)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, rule");
    {
	DBusConnection *	con;
	char *	rule = (char *)SvPV_nolen(ST(1))
;
#line 775 "DBus.xs"
	DBusError error;
#line 1394 "DBus.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_remove_match() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 777 "DBus.xs"
	dbus_error_init(&error);
	DEBUG_MSG("Removeing match %s\n", rule);
	dbus_bus_remove_match(con, rule, &error);
	if (dbus_error_is_set(&error)) {
	  _croak_error(&error);
	}
#line 1410 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_get_unique_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_get_unique_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_get_unique_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_bus_get_unique_name(con);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_request_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_dbus_bus_request_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, service_name");
    {
	DBusConnection *	con;
	char *	service_name = (char *)SvPV_nolen(ST(1))
;
#line 793 "DBus.xs"
	DBusError error;
	int reply;
#line 1455 "DBus.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_request_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 796 "DBus.xs"
	dbus_error_init(&error);
	if (!(reply = dbus_bus_request_name(con, service_name, 0, &error))) {
	  _croak_error(&error);
	}
	RETVAL = reply;
#line 1472 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Connection_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Connection_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::DESTROY() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 808 "DBus.xs"
	DEBUG_MSG("Unrefing connection %p\n", con);
	dbus_connection_unref(con);
#line 1498 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Server__open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Server__open)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "address");
    {
	char *	address = (char *)SvPV_nolen(ST(0))
;
#line 820 "DBus.xs"
	DBusError error;
	DBusServer *server;
#line 1516 "DBus.c"
	DBusServer *	RETVAL;
#line 823 "DBus.xs"
	dbus_error_init(&error);
	server = dbus_server_listen(address, &error);
	DEBUG_MSG("Created server %p on address %s\n", server, address);
	if (!server) {
	  _croak_error(&error);
	}
	if (!dbus_server_set_auth_mechanisms(server, NULL)) {
	    croak("not enough memory to server auth mechanisms");
	}
	RETVAL = server;
#line 1529 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Server", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_owner); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_owner)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "server, owner");
    {
	DBusServer *	server;
	SV *	owner = ST(1)
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_owner() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 844 "DBus.xs"
	SvREFCNT_inc(owner);
	dbus_server_set_data(server, server_data_slot, owner, _object_release);
#line 1558 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server_dbus_server_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server_dbus_server_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "server");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::dbus_server_disconnect() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_server_disconnect(server);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server_dbus_server_get_is_connected); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server_dbus_server_get_is_connected)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "server");
    {
	DBusServer *	server;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::dbus_server_get_is_connected() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_server_get_is_connected(server);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_watch_callbacks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_watch_callbacks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "server");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_watch_callbacks() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 859 "DBus.xs"
	if (!dbus_server_set_watch_functions(server,
					     _watch_server_add,
					     _watch_server_remove,
					     _watch_server_toggled,
					     server, NULL)) {
	  croak("not enough memory to set watch functions on server");
	}
#line 1637 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_timeout_callbacks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_timeout_callbacks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "server");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_timeout_callbacks() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 872 "DBus.xs"
	if (!dbus_server_set_timeout_functions(server,
					       _timeout_server_add,
					       _timeout_server_remove,
					       _timeout_server_toggled,
					       server, NULL)) {
	  croak("not enough memory to set timeout functions on server");
	}
#line 1667 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_connection_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server__set_connection_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "server");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_connection_callback() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 885 "DBus.xs"
	dbus_server_set_new_connection_function(server,
						_connection_callback,
						server, NULL);
#line 1693 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Server_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Server_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "server");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::DESTROY() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 893 "DBus.xs"
	DEBUG_MSG("Destroying server %p\n", server);
	dbus_server_unref(server);
#line 1718 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Bus__open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Bus__open)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "type");
    {
	DBusBusType	type = (DBusBusType)SvIV(ST(0))
;
#line 905 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 1736 "DBus.c"
	DBusConnection *	RETVAL;
#line 908 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open bus shared %d\n", type);
	con = dbus_bus_get(type, &error);
	if (!con) {
	  _croak_error(&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 1747 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Bus__open_private); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Bus__open_private)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "type");
    {
	DBusBusType	type = (DBusBusType)SvIV(ST(0))
;
#line 923 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 1767 "DBus.c"
	DBusConnection *	RETVAL;
#line 926 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open bus private %d\n", type);
	con = dbus_bus_get_private(type, &error);
	if (!con) {
	  _croak_error(&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 1778 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Message__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "type");
    {
	IV	type = (IV)SvIV(ST(0))
;
#line 945 "DBus.xs"
	DBusMessage *msg;
#line 1797 "DBus.c"
	DBusMessage *	RETVAL;
#line 947 "DBus.xs"
	msg = dbus_message_new(type);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	RETVAL = msg;
#line 1807 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Message__iterator_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__iterator_append)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::_iterator_append() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 962 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	dbus_message_iter_init_append(msg, RETVAL);
#line 1835 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Message__iterator); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__iterator)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::_iterator() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 972 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	dbus_message_iter_init(msg, RETVAL);
#line 1863 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::DESTROY() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 984 "DBus.xs"
	DEBUG_MSG("De-referencing message %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	dbus_message_unref(msg);
#line 1894 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_no_reply); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_no_reply)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_no_reply() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_no_reply(msg);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_set_no_reply); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_set_no_reply)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "msg, flag");
    {
	DBusMessage *	msg;
	dbus_bool_t	flag = (bool)SvTRUE(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_set_no_reply() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_message_set_no_reply(msg, flag);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_type() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_type(msg);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_interface); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_interface)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_interface() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_interface(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_path() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_path(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_destination); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_destination)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_destination() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_destination(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_sender); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_sender)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_sender() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_sender(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_serial); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_serial)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	dbus_uint32_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_serial() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_serial(msg);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_member); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_member)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_member() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_member(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_error_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_error_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_error_name() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_error_name(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_signature); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_get_signature)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "msg");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_signature() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_message_get_signature(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_set_sender); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_set_sender)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "msg, sender");
    {
	DBusMessage *	msg;
	const char *	sender = (const char *)SvPV_nolen(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_set_sender() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_message_set_sender(msg, sender);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_set_destination); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Message_dbus_message_set_destination)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "msg, dest");
    {
	DBusMessage *	msg;
	const char *	dest = (const char *)SvPV_nolen(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_set_destination() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_message_set_destination(msg, dest);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Message__Signal__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__Signal__create)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "path, interface, name");
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	char *	interface = (char *)SvPV_nolen(ST(1))
;
	char *	name = (char *)SvPV_nolen(ST(2))
;
#line 1056 "DBus.xs"
	DBusMessage *msg;
#line 2250 "DBus.c"
	DBusMessage *	RETVAL;
#line 1058 "DBus.xs"
	msg = dbus_message_new_signal(path, interface, name);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new signal %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2263 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Message__MethodCall__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__MethodCall__create)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "service, path, interface, method");
    {
	char *	service = (char *)SvPV_nolen(ST(0))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	interface = (char *)SvPV_nolen(ST(2))
;
	char *	method = (char *)SvPV_nolen(ST(3))
;
#line 1082 "DBus.xs"
	DBusMessage *msg;
#line 2288 "DBus.c"
	DBusMessage *	RETVAL;
#line 1084 "DBus.xs"
	msg = dbus_message_new_method_call(service, path, interface, method);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new method call %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2301 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Message__MethodReturn__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__MethodReturn__create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "call");
    {
	DBusMessage *	call;
#line 1105 "DBus.xs"
	DBusMessage *msg;
#line 2319 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::MethodReturn::_create() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1107 "DBus.xs"
	msg = dbus_message_new_method_return(call);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	dbus_message_set_interface(msg, dbus_message_get_interface(call));
	dbus_message_set_path(msg, dbus_message_get_path(call));
	dbus_message_set_member(msg, dbus_message_get_member(call));
	DEBUG_MSG("Create msg new method return %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2343 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Message__Error__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Message__Error__create)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "replyto, name, message");
    {
	DBusMessage *	replyto;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	message = (char *)SvPV_nolen(ST(2))
;
#line 1133 "DBus.xs"
	DBusMessage *msg;
#line 2365 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        replyto = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::Error::_create() -- replyto is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1135 "DBus.xs"
	msg = dbus_message_new_error(replyto, name, message);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new error %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2386 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall__steal_reply); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall__steal_reply)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "call");
    {
	DBusPendingCall *	call;
#line 1156 "DBus.xs"
        DBusMessage *msg;
#line 2404 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::_steal_reply() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1158 "DBus.xs"
        DEBUG_MSG("Stealing pending call reply %p\n", call);
	msg = dbus_pending_call_steal_reply(call);
        dbus_message_ref(msg);
        DEBUG_MSG("Got reply message %p\n", msg);
        RETVAL = msg;
#line 2420 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_block)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "call");
    {
	DBusPendingCall *	call;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::dbus_pending_call_block() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_pending_call_block(call);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_get_completed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_get_completed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "call");
    {
	DBusPendingCall *	call;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::dbus_pending_call_get_completed() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	RETVAL = dbus_pending_call_get_completed(call);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "call");
    {
	DBusPendingCall *	call;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::dbus_pending_call_cancel() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	dbus_pending_call_cancel(call);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall__set_notify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall__set_notify)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "call, code");
    {
	DBusPendingCall *	call;
	SV *	code = ST(1)
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::_set_notify() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1183 "DBus.xs"
	SvREFCNT_inc(code);
	DEBUG_MSG("Adding pending call notify %p\n", code);
	dbus_pending_call_set_notify(call, _pending_call_callback, code, _pending_call_notify_release);
#line 2522 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__PendingCall_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "call");
    {
	DBusPendingCall *	call;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::DESTROY() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1191 "DBus.xs"
	DEBUG_MSG("Unrefing pending call %p", call);
	dbus_pending_call_unref(call);
#line 2547 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Watch_get_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Watch_get_fileno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    {
	DBusWatch *	watch;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::get_fileno() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1200 "DBus.xs"
	RETVAL = dbus_watch_get_unix_fd(watch);
#line 2573 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Watch_get_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Watch_get_flags)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    {
	DBusWatch *	watch;
	unsigned int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::get_flags() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1208 "DBus.xs"
	RETVAL = dbus_watch_get_flags(watch);
#line 2600 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Watch_is_enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Watch_is_enabled)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    {
	DBusWatch *	watch;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::is_enabled() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1216 "DBus.xs"
	RETVAL = dbus_watch_get_enabled(watch);
#line 2626 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Watch_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Watch_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "watch, flags");
    {
	DBusWatch *	watch;
	unsigned int	flags = (unsigned int)SvUV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::handle() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1225 "DBus.xs"
	DEBUG_MSG("Handling event %d on fd %d (%p)\n", flags, dbus_watch_get_unix_fd(watch), watch);
	dbus_watch_handle(watch, flags);
#line 2655 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Watch_get_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Watch_get_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    {
	DBusWatch *	watch;
	void *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::get_data() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1233 "DBus.xs"
	RETVAL = dbus_watch_get_data(watch);
#line 2681 "DBus.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Watch_set_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Watch_set_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "watch, data");
    {
	DBusWatch *	watch;
	void *	data = INT2PTR(void *,SvIV(ST(1)))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::set_data() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1242 "DBus.xs"
	dbus_watch_set_data(watch, data, NULL);
#line 2708 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_get_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_get_interval)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timeout");
    {
	DBusTimeout *	timeout;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::get_interval() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1251 "DBus.xs"
	RETVAL = dbus_timeout_get_interval(timeout);
#line 2734 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_is_enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_is_enabled)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timeout");
    {
	DBusTimeout *	timeout;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::is_enabled() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1259 "DBus.xs"
	RETVAL = dbus_timeout_get_enabled(timeout);
#line 2760 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timeout");
    {
	DBusTimeout *	timeout;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::handle() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1267 "DBus.xs"
	DEBUG_MSG("Handling timeout event %p\n", timeout);
	dbus_timeout_handle(timeout);
#line 2787 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_get_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_get_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timeout");
    {
	DBusTimeout *	timeout;
	void *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::get_data() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1274 "DBus.xs"
	RETVAL = dbus_timeout_get_data(timeout);
#line 2813 "DBus.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_set_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__C__Timeout_set_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "timeout, data");
    {
	DBusTimeout *	timeout;
	void *	data = INT2PTR(void *,SvIV(ST(1)))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::set_data() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1283 "DBus.xs"
	dbus_timeout_set_data(timeout, data, NULL);
#line 2840 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__recurse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__recurse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_recurse() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1291 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	dbus_message_iter_recurse(iter, RETVAL);
#line 2866 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__open_container); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__open_container)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "iter, type, sig");
    {
	DBusMessageIter *	iter;
	int	type = (int)SvIV(ST(1))
;
	char *	sig = (char *)SvPV_nolen(ST(2))
;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_open_container() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1302 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	if (!dbus_message_iter_open_container(iter, type, sig && *sig == '\0' ? NULL : sig, RETVAL)) {
		dbus_free(RETVAL);
		croak("failed to open iterator container");
	}
#line 2901 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__close_container); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__close_container)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, sub_iter");
    {
	DBusMessageIter *	iter;
	DBusMessageIter *	sub_iter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_close_container() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        sub_iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_close_container() -- sub_iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1315 "DBus.xs"
	dbus_message_iter_close_container(iter, sub_iter);
#line 2936 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_arg_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_arg_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_arg_type() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1321 "DBus.xs"
	RETVAL = dbus_message_iter_get_arg_type(iter);
#line 2962 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_element_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_element_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_element_type() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1329 "DBus.xs"
	RETVAL = dbus_message_iter_get_element_type(iter);
#line 2989 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_has_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_has_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::has_next() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1337 "DBus.xs"
	RETVAL = dbus_message_iter_has_next(iter);
#line 3015 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::next() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1345 "DBus.xs"
	RETVAL = dbus_message_iter_next(iter);
#line 3042 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_boolean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_boolean)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_boolean() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1353 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3069 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_byte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_byte)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	unsigned char	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_byte() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1361 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3097 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_int16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_int16)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_int16_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_int16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1369 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3124 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_uint16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_uint16)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_uint16_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_uint16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1377 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3151 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_int32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_int32)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_int32_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_int32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1385 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3178 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_uint32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_uint32)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_uint32_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_uint32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1393 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3205 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__get_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__get_int64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_int64_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_get_int64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1401 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3231 "DBus.c"
    ST(0) = _dbus_format_int64(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__get_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__get_uint64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	dbus_uint64_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_get_uint64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1409 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3258 "DBus.c"
    ST(0) = _dbus_format_uint64(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_double)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	double	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_double() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1417 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3286 "DBus.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_string() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1425 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3313 "DBus.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_signature); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_signature)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_signature() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1433 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3340 "DBus.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_object_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_get_object_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_object_path() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1441 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3367 "DBus.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_boolean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_boolean)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	val = (bool)SvTRUE(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_boolean() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1451 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_BOOLEAN, &val)) {
	  croak("cannot append boolean");
	}
#line 3396 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_byte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_byte)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	unsigned char	val = (unsigned char)SvUV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_byte() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1460 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_BYTE, &val)) {
	  croak("cannot append byte");
	}
#line 3424 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_int16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_int16)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_int16_t	val = (dbus_int16_t)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_int16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1469 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_INT16, &val)) {
	  croak("cannot append int16");
	}
#line 3452 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_uint16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_uint16)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_uint16_t	val = (dbus_uint16_t)SvUV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_uint16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1478 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_UINT16, &val)) {
	  croak("cannot append uint16");
	}
#line 3480 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_int32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_int32)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_int32_t	val = (dbus_int32_t)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_int32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1487 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_INT32, &val)) {
	  croak("cannot append int32");
	}
#line 3508 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_uint32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_uint32)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_uint32_t	val = (dbus_uint32_t)SvUV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_uint32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1496 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_UINT32, &val)) {
	  croak("cannot append uint32");
	}
#line 3536 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__append_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__append_int64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_int64_t    val = _dbus_parse_int64(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_append_int64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1505 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_INT64, &val)) {
	  croak("cannot append int64");
	}
#line 3564 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator__append_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator__append_uint64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	dbus_uint64_t    val = _dbus_parse_uint64(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_append_uint64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1514 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_UINT64, &val)) {
	  croak("cannot append uint64");
	}
#line 3592 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_double)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	double	val = (double)SvNV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_double() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1523 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_DOUBLE, &val)) {
	  croak("cannot append double");
	}
#line 3620 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	char *	val = (char *)SvPV_nolen(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_string() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1532 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_STRING, &val)) {
	  croak("cannot append string");
	}
#line 3648 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_object_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_object_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	char *	val = (char *)SvPV_nolen(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_object_path() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1541 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_OBJECT_PATH, &val)) {
	  croak("cannot append object path");
	}
#line 3676 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_signature); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_append_signature)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "iter, val");
    {
	DBusMessageIter *	iter;
	char *	val = (char *)SvPV_nolen(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_signature() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1550 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_SIGNATURE, &val)) {
	  croak("cannot append signature");
	}
#line 3704 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DBus__Binding__Iterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DBus__Binding__Iterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	DBusMessageIter *	iter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::DESTROY() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1560 "DBus.xs"
	DEBUG_MSG("Destroying iterator %p\n", iter);
	dbus_free(iter);
#line 3729 "DBus.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__DBus); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__DBus)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        (void)newXSproto_portable("Net::DBus::Binding::Connection::_open", XS_Net__DBus__Binding__Connection__open, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Connection::_open_private", XS_Net__DBus__Binding__Connection__open_private, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_set_owner", XS_Net__DBus__Binding__C__Connection__set_owner, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_disconnect", XS_Net__DBus__Binding__C__Connection_dbus_connection_disconnect, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_ref", XS_Net__DBus__Binding__C__Connection_dbus_connection_ref, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_unref", XS_Net__DBus__Binding__C__Connection_dbus_connection_unref, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_get_is_connected", XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_connected, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_get_is_authenticated", XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_authenticated, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_flush", XS_Net__DBus__Binding__C__Connection_dbus_connection_flush, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_send", XS_Net__DBus__Binding__C__Connection__send, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_send_with_reply_and_block", XS_Net__DBus__Binding__C__Connection__send_with_reply_and_block, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_send_with_reply", XS_Net__DBus__Binding__C__Connection__send_with_reply, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_borrow_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_borrow_message, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_return_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_return_message, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_steal_borrowed_message, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_connection_pop_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_pop_message, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_dispatch", XS_Net__DBus__Binding__C__Connection__dispatch, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_set_watch_callbacks", XS_Net__DBus__Binding__C__Connection__set_watch_callbacks, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_set_timeout_callbacks", XS_Net__DBus__Binding__C__Connection__set_timeout_callbacks, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_register_object_path", XS_Net__DBus__Binding__C__Connection__register_object_path, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_unregister_object_path", XS_Net__DBus__Binding__C__Connection__unregister_object_path, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_register_fallback", XS_Net__DBus__Binding__C__Connection__register_fallback, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::_add_filter", XS_Net__DBus__Binding__C__Connection__add_filter, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_bus_register", XS_Net__DBus__Binding__C__Connection_dbus_bus_register, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_bus_add_match", XS_Net__DBus__Binding__C__Connection_dbus_bus_add_match, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_bus_remove_match", XS_Net__DBus__Binding__C__Connection_dbus_bus_remove_match, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_bus_get_unique_name", XS_Net__DBus__Binding__C__Connection_dbus_bus_get_unique_name, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::dbus_bus_request_name", XS_Net__DBus__Binding__C__Connection_dbus_bus_request_name, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Connection::DESTROY", XS_Net__DBus__Binding__C__Connection_DESTROY, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Server::_open", XS_Net__DBus__Binding__Server__open, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::_set_owner", XS_Net__DBus__Binding__C__Server__set_owner, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::dbus_server_disconnect", XS_Net__DBus__Binding__C__Server_dbus_server_disconnect, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::dbus_server_get_is_connected", XS_Net__DBus__Binding__C__Server_dbus_server_get_is_connected, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::_set_watch_callbacks", XS_Net__DBus__Binding__C__Server__set_watch_callbacks, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::_set_timeout_callbacks", XS_Net__DBus__Binding__C__Server__set_timeout_callbacks, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::_set_connection_callback", XS_Net__DBus__Binding__C__Server__set_connection_callback, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Server::DESTROY", XS_Net__DBus__Binding__C__Server_DESTROY, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Bus::_open", XS_Net__DBus__Binding__Bus__open, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Bus::_open_private", XS_Net__DBus__Binding__Bus__open_private, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::_create", XS_Net__DBus__Binding__Message__create, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::_iterator_append", XS_Net__DBus__Binding__Message__iterator_append, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::_iterator", XS_Net__DBus__Binding__Message__iterator, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::DESTROY", XS_Net__DBus__Binding__C__Message_DESTROY, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_no_reply", XS_Net__DBus__Binding__C__Message_dbus_message_get_no_reply, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_set_no_reply", XS_Net__DBus__Binding__C__Message_dbus_message_set_no_reply, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_type", XS_Net__DBus__Binding__C__Message_dbus_message_get_type, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_interface", XS_Net__DBus__Binding__C__Message_dbus_message_get_interface, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_path", XS_Net__DBus__Binding__C__Message_dbus_message_get_path, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_destination", XS_Net__DBus__Binding__C__Message_dbus_message_get_destination, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_sender", XS_Net__DBus__Binding__C__Message_dbus_message_get_sender, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_serial", XS_Net__DBus__Binding__C__Message_dbus_message_get_serial, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_member", XS_Net__DBus__Binding__C__Message_dbus_message_get_member, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_error_name", XS_Net__DBus__Binding__C__Message_dbus_message_get_error_name, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_get_signature", XS_Net__DBus__Binding__C__Message_dbus_message_get_signature, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_set_sender", XS_Net__DBus__Binding__C__Message_dbus_message_set_sender, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Message::dbus_message_set_destination", XS_Net__DBus__Binding__C__Message_dbus_message_set_destination, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::Signal::_create", XS_Net__DBus__Binding__Message__Signal__create, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::MethodCall::_create", XS_Net__DBus__Binding__Message__MethodCall__create, file, "$$$$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::MethodReturn::_create", XS_Net__DBus__Binding__Message__MethodReturn__create, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Message::Error::_create", XS_Net__DBus__Binding__Message__Error__create, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::PendingCall::_steal_reply", XS_Net__DBus__Binding__C__PendingCall__steal_reply, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::PendingCall::dbus_pending_call_block", XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_block, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::PendingCall::dbus_pending_call_get_completed", XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_get_completed, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::PendingCall::dbus_pending_call_cancel", XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_cancel, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::PendingCall::_set_notify", XS_Net__DBus__Binding__C__PendingCall__set_notify, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::PendingCall::DESTROY", XS_Net__DBus__Binding__C__PendingCall_DESTROY, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Watch::get_fileno", XS_Net__DBus__Binding__C__Watch_get_fileno, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Watch::get_flags", XS_Net__DBus__Binding__C__Watch_get_flags, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Watch::is_enabled", XS_Net__DBus__Binding__C__Watch_is_enabled, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Watch::handle", XS_Net__DBus__Binding__C__Watch_handle, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Watch::get_data", XS_Net__DBus__Binding__C__Watch_get_data, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Watch::set_data", XS_Net__DBus__Binding__C__Watch_set_data, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Timeout::get_interval", XS_Net__DBus__Binding__C__Timeout_get_interval, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Timeout::is_enabled", XS_Net__DBus__Binding__C__Timeout_is_enabled, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Timeout::handle", XS_Net__DBus__Binding__C__Timeout_handle, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Timeout::get_data", XS_Net__DBus__Binding__C__Timeout_get_data, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::C::Timeout::set_data", XS_Net__DBus__Binding__C__Timeout_set_data, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_recurse", XS_Net__DBus__Binding__Iterator__recurse, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_open_container", XS_Net__DBus__Binding__Iterator__open_container, file, "$$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_close_container", XS_Net__DBus__Binding__Iterator__close_container, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_arg_type", XS_Net__DBus__Binding__Iterator_get_arg_type, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_element_type", XS_Net__DBus__Binding__Iterator_get_element_type, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::has_next", XS_Net__DBus__Binding__Iterator_has_next, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::next", XS_Net__DBus__Binding__Iterator_next, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_boolean", XS_Net__DBus__Binding__Iterator_get_boolean, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_byte", XS_Net__DBus__Binding__Iterator_get_byte, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_int16", XS_Net__DBus__Binding__Iterator_get_int16, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_uint16", XS_Net__DBus__Binding__Iterator_get_uint16, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_int32", XS_Net__DBus__Binding__Iterator_get_int32, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_uint32", XS_Net__DBus__Binding__Iterator_get_uint32, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_get_int64", XS_Net__DBus__Binding__Iterator__get_int64, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_get_uint64", XS_Net__DBus__Binding__Iterator__get_uint64, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_double", XS_Net__DBus__Binding__Iterator_get_double, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_string", XS_Net__DBus__Binding__Iterator_get_string, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_signature", XS_Net__DBus__Binding__Iterator_get_signature, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::get_object_path", XS_Net__DBus__Binding__Iterator_get_object_path, file, "$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_boolean", XS_Net__DBus__Binding__Iterator_append_boolean, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_byte", XS_Net__DBus__Binding__Iterator_append_byte, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_int16", XS_Net__DBus__Binding__Iterator_append_int16, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_uint16", XS_Net__DBus__Binding__Iterator_append_uint16, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_int32", XS_Net__DBus__Binding__Iterator_append_int32, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_uint32", XS_Net__DBus__Binding__Iterator_append_uint32, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_append_int64", XS_Net__DBus__Binding__Iterator__append_int64, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::_append_uint64", XS_Net__DBus__Binding__Iterator__append_uint64, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_double", XS_Net__DBus__Binding__Iterator_append_double, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_string", XS_Net__DBus__Binding__Iterator_append_string, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_object_path", XS_Net__DBus__Binding__Iterator_append_object_path, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::append_signature", XS_Net__DBus__Binding__Iterator_append_signature, file, "$$");
        (void)newXSproto_portable("Net::DBus::Binding::Iterator::DESTROY", XS_Net__DBus__Binding__Iterator_DESTROY, file, "$");

    /* Initialisation Section */

#line 468 "DBus.xs"
    {
	HV *constants;

	if (getenv("NET_DBUS_DEBUG"))
	  net_dbus_debug = 1;

	/* not the 'standard' way of doing perl constants, but a lot easier to maintain */

	constants = perl_get_hv("Net::DBus::Binding::Bus::_constants", TRUE);
	REGISTER_CONSTANT(DBUS_BUS_SYSTEM, SYSTEM);
	REGISTER_CONSTANT(DBUS_BUS_SESSION, SESSION);
	REGISTER_CONSTANT(DBUS_BUS_STARTER, STARTER);

	constants = perl_get_hv("Net::DBus::Binding::Message::_constants", TRUE);
	REGISTER_CONSTANT(DBUS_TYPE_ARRAY, TYPE_ARRAY);
	REGISTER_CONSTANT(DBUS_TYPE_BOOLEAN, TYPE_BOOLEAN);
	REGISTER_CONSTANT(DBUS_TYPE_BYTE, TYPE_BYTE);
	REGISTER_CONSTANT(DBUS_TYPE_DOUBLE, TYPE_DOUBLE);
	REGISTER_CONSTANT(DBUS_TYPE_INT16, TYPE_INT16);
	REGISTER_CONSTANT(DBUS_TYPE_INT32, TYPE_INT32);
	REGISTER_CONSTANT(DBUS_TYPE_INT64, TYPE_INT64);
	REGISTER_CONSTANT(DBUS_TYPE_INVALID, TYPE_INVALID);
	REGISTER_CONSTANT(DBUS_TYPE_STRUCT, TYPE_STRUCT);
	REGISTER_CONSTANT(DBUS_TYPE_SIGNATURE, TYPE_SIGNATURE);
	REGISTER_CONSTANT(DBUS_TYPE_OBJECT_PATH, TYPE_OBJECT_PATH);
	REGISTER_CONSTANT(DBUS_TYPE_DICT_ENTRY, TYPE_DICT_ENTRY);
	REGISTER_CONSTANT(DBUS_TYPE_STRING, TYPE_STRING);
	REGISTER_CONSTANT(DBUS_TYPE_UINT16, TYPE_UINT16);
	REGISTER_CONSTANT(DBUS_TYPE_UINT32, TYPE_UINT32);
	REGISTER_CONSTANT(DBUS_TYPE_UINT64, TYPE_UINT64);
	REGISTER_CONSTANT(DBUS_TYPE_VARIANT, TYPE_VARIANT);

	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_METHOD_CALL, MESSAGE_TYPE_METHOD_CALL);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_METHOD_RETURN, MESSAGE_TYPE_METHOD_RETURN);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_ERROR, MESSAGE_TYPE_ERROR);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_SIGNAL, MESSAGE_TYPE_SIGNAL);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_INVALID, MESSAGE_TYPE_INVALID);

	constants = perl_get_hv("Net::DBus::Binding::Watch::_constants", TRUE);
	REGISTER_CONSTANT(DBUS_WATCH_READABLE, READABLE);
	REGISTER_CONSTANT(DBUS_WATCH_WRITABLE, WRITABLE);
	REGISTER_CONSTANT(DBUS_WATCH_ERROR, ERROR);
	REGISTER_CONSTANT(DBUS_WATCH_HANGUP, HANGUP);

	dbus_connection_allocate_data_slot(&connection_data_slot);
	dbus_server_allocate_data_slot(&server_data_slot);
	dbus_pending_call_allocate_data_slot(&pending_call_data_slot);
    }

#line 3916 "DBus.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

